"
 COPYRIGHT (c) 1996-2011 by Claus Gittinger

 New code and modifications done at SWING Research Group [1]:

 COPYRIGHT (c) 2010-2011 by Jan Vrany, Jan Kurs and Marcel Hlopko
                            SWING Research Group, Czech Technical University in Prague

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.

 [1] Code written at SWING Research Group contains a signature
     of one of the above copright owners. For exact set of such code,
     see the differences between this version and version stx:libjava
     as of 1.9.2010
"
"{ Package: 'stx:libjava' }"

TestCase subclass:#JavaSelectorParserTests
	instanceVariableNames:'p h'
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Java-Lookup-Tests'
!

!JavaSelectorParserTests class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1996-2011 by Claus Gittinger

 New code and modifications done at SWING Research Group [1]:

 COPYRIGHT (c) 2010-2011 by Jan Vrany, Jan Kurs and Marcel Hlopko
                            SWING Research Group, Czech Technical University in Prague

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.

 [1] Code written at SWING Research Group contains a signature
     of one of the above copright owners. For exact set of such code,
     see the differences between this version and version stx:libjava
     as of 1.9.2010

"
! !

!JavaSelectorParserTests methodsFor:'running'!

setUp
    p := JavaSelectorParser new.
    h := SampleHandler new.

    "Created: / 29-08-2011 / 22:41:22 / Jan Kurs <kursjan@fit.cvut.cz>"
!

testConstructor

    |event|

    p parse: '<init>()V' handler: h.
    self assert: h events size = 2.
    event := h events first.
    self assert: event first = #name.
    self assert: event second = '<init>'.

    event := h events second.
    self assert: event first = #returnType.

    "Created: / 29-08-2011 / 22:43:06 / Jan Kurs <kursjan@fit.cvut.cz>"
!

testConstructor2

    |event|

    p parse: '<init>(l)V' handler: h.
    self assert: h events size = 3.
    event := h events first.
    self assert: event first = #name.
    self assert: event second = '<init>'.

    event := h events second.
    self assert: event first = #addArgumentOfType.

    event := h events third.
    self assert: event first = #returnType.

    "Created: / 29-08-2011 / 22:55:10 / Jan Kurs <kursjan@fit.cvut.cz>"
!

testConstructor3

    |event|

    p parse: '<init>(Ljava/lang/String;)V' handler: h.
    self assert: h events size = 3.
    event := h events first.
    self assert: event first = #name.
    self assert: event second = '<init>'.

    event := h events second.
    self assert: event first = #addArgumentOfType.

    event := h events third.
    self assert: event first = #returnType.

    "Created: / 29-08-2011 / 22:57:14 / Jan Kurs <kursjan@fit.cvut.cz>"
!

testMethod

    |event|

    p parse: 'sayHello()V' handler: h.
    self assert: h events size = 2.
    event := h events first.
    self assert: event first = #name.
    self assert: event second = 'sayHello'.

    event := h events second.
    self assert: event first = #returnType.

    "Created: / 29-08-2011 / 22:57:41 / Jan Kurs <kursjan@fit.cvut.cz>"
!

testMethod2

    |event|

    p parse: 'sayHello()Ljava/lang/String;' handler: h.
    self assert: h events size = 2.
    event := h events first.
    self assert: event first = #name.
    self assert: event second = 'sayHello'.

    event := h events second.
    self assert: event first = #returnType.

    "Created: / 29-08-2011 / 22:58:44 / Jan Kurs <kursjan@fit.cvut.cz>"
!

testMethod3

    |event|

    p parse: 'sayHello()l' handler: h.
    self assert: h events size = 2.
    event := h events first.
    self assert: event first = #name.
    self assert: event second = 'sayHello'.

    event := h events second.
    self assert: event first = #returnType.

    "Created: / 29-08-2011 / 22:59:06 / Jan Kurs <kursjan@fit.cvut.cz>"
!

testMethod4

    |event|

    p parse: #'replace(Ljava/lang/CharSequence;Ljava/lang/CharSequence;)Ljava/lang/String;' handler: h.
    self assert: h events size = 4.
    event := h events first.
    self assert: event first = #name.
    self assert: event second = 'replace'.

    event := h events second.
    self assert: event first = #addArgumentOfType.
    event := h events third.
    self assert: event first = #addArgumentOfType.

    event := h events fourth.
    self assert: event first = #returnType.

    "Created: / 30-08-2011 / 21:42:54 / Jan Kurs <kursjan@fit.cvut.cz>"
!

testMethodWithArgs

    |event|

    p parse: 'sayHello(l)l' handler: h.
    self assert: h events size = 3.
    event := h events first.
    self assert: event first = #name.
    self assert: event second = 'sayHello'.

    event := h events second.
    self assert: event first = #addArgumentOfType.

    event := h events third.
    self assert: event first = #returnType.

    "Created: / 29-08-2011 / 22:59:49 / Jan Kurs <kursjan@fit.cvut.cz>"
!

testMethodWithArgs2

    |event|

    p parse: 'sayHello(l)V' handler: h.
    self assert: h events size = 3.
    event := h events first.
    self assert: event first = #name.
    self assert: event second = 'sayHello'.

    event := h events second.
    self assert: event first = #addArgumentOfType.

    event := h events third.
    self assert: event first = #returnType.

    "Created: / 29-08-2011 / 23:00:18 / Jan Kurs <kursjan@fit.cvut.cz>"
!

testMethodWithArgs3

    |event|

    p parse: 'sayHello(Ljava/lang/String;)V' handler: h.
    self assert: h events size = 3.
    event := h events first.
    self assert: event first = #name.
    self assert: event second = 'sayHello'.

    event := h events second.
    self assert: event first = #addArgumentOfType.

    event := h events third.
    self assert: event first = #returnType.

    "Created: / 29-08-2011 / 23:01:00 / Jan Kurs <kursjan@fit.cvut.cz>"
!

testMethodWithArgs4

    |event|

    p parse: 'sayHello(Ljava/lang/String;)Ljava/lang/Integer;' handler: h.
    self assert: h events size = 3.
    event := h events first.
    self assert: event first = #name.
    self assert: event second = 'sayHello'.

    event := h events second.
    self assert: event first = #addArgumentOfType.

    event := h events third.
    self assert: event first = #returnType.

    "Created: / 29-08-2011 / 23:01:19 / Jan Kurs <kursjan@fit.cvut.cz>"
!

testMethodWithArgs5

    |event|

    p parse: 'sayHello(Ljava/lang/String;l)Ljava/lang/Integer;' handler: h.
    self assert: h events size = 4.
    event := h events first.
    self assert: event first = #name.
    self assert: event second = 'sayHello'.

    event := h events second.
    self assert: event first = #addArgumentOfType.
    event := h events third.
    self assert: event first = #addArgumentOfType.

    event := h events fourth.
    self assert: event first = #returnType.

    "Created: / 29-08-2011 / 23:01:52 / Jan Kurs <kursjan@fit.cvut.cz>"
!

testMethodWithArgs6

    |event|

    p parse: 'sayHello(lLjava/lang/String;)Ljava/lang/Integer;' handler: h.
    self assert: h events size = 4.
    event := h events first.
    self assert: event first = #name.
    self assert: event second = 'sayHello'.

    event := h events second.
    self assert: event first = #addArgumentOfType.
    event := h events third.
    self assert: event first = #addArgumentOfType.

    event := h events fourth.
    self assert: event first = #returnType.

    "Created: / 29-08-2011 / 23:02:04 / Jan Kurs <kursjan@fit.cvut.cz>"
!

testMethodWithArgs7

    |event|

    p parse: 'sayHello(ll)l' handler: h.
    self assert: h events size = 4.
    event := h events first.
    self assert: event first = #name.
    self assert: event second = 'sayHello'.

    event := h events second.
    self assert: event first = #addArgumentOfType.
    event := h events third.
    self assert: event first = #addArgumentOfType.

    event := h events fourth.
    self assert: event first = #returnType.

    "Created: / 29-08-2011 / 23:02:17 / Jan Kurs <kursjan@fit.cvut.cz>"
!

testMethodWithArgs8

    |event|

    p parse: 'sayHello(ll)Ljava/lang/Integer;' handler: h.
    self assert: h events size = 4.
    event := h events first.
    self assert: event first = #name.
    self assert: event second = 'sayHello'.

    event := h events second.
    self assert: event first = #addArgumentOfType.
    event := h events third.
    self assert: event first = #addArgumentOfType.

    event := h events fourth.
    self assert: event first = #returnType.

    "Created: / 29-08-2011 / 23:17:48 / Jan Kurs <kursjan@fit.cvut.cz>"
!

testMethodWithArgs9

    |event|

    p parse: 'sayHello(lLjava/lang/String;l)Ljava/lang/Integer;' handler: h.
    self assert: h events size = 5.
    event := h events first.
    self assert: event first = #name.
    self assert: event second = 'sayHello'.

    event := h events second.
    self assert: event first = #addArgumentOfType.
    event := h events third.
    self assert: event first = #addArgumentOfType.
    event := h events fourth.
    self assert: event first = #addArgumentOfType.

    event := h events fifth.
    self assert: event first = #returnType.

    "Created: / 29-08-2011 / 23:18:12 / Jan Kurs <kursjan@fit.cvut.cz>"
! !

!JavaSelectorParserTests class methodsFor:'documentation'!

version_SVN
    ^ '$Id$'
! !
