"
 Copyright (c) 2010-2011 Jan Vrany, Jan Kurs & Marcel Hlopko,
                         SWING Research Group, Czech Technical University 
                         in Prague

 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the 'Software'), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.
"
"{ Package: 'stx:libjava/experiments' }"

Method variableSubclass:#GuardedMethod
	instanceVariableNames:'guard'
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Java-Experiments-Support'
!

!GuardedMethod class methodsFor:'documentation'!

copyright
"
 Copyright (c) 2010-2011 Jan Vrany, Jan Kurs & Marcel Hlopko,
                         SWING Research Group, Czech Technical University 
                         in Prague

 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the 'Software'), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.

"
! !

!GuardedMethod class methodsFor:'initialization'!

initialize
    "Invoked at system start or when the class is dynamically loaded."

    self makeMetaMethod

    "Modified: / 06-12-2011 / 21:19:21 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!GuardedMethod class methodsFor:'misc'!

makeMetaMethod

    self flags:((self flags 
                 bitOr:Behavior flagMetaMethod)
                 bitClear:Behavior flagMethod)

    "
        GuardedMethod makeNormalMethod
        GuardedMethod makeMetaMethod
    "

    "Created: / 06-12-2011 / 21:19:01 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

makeNormalMethod

    self flags:((self flags 
                 bitOr:Behavior flagMethod)
                 bitClear:Behavior flagMetaMethod)

    "
        GuardedMethod makeNormalMethod
        GuardedMethod makeMetaMethod
    "

    "Created: / 06-12-2011 / 21:18:39 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!GuardedMethod methodsFor:'accessing'!

interpretWithReceiver: receiver

    ^self interpretWithReceiver: receiver arguments: #()

    "Created: / 06-12-2011 / 21:21:12 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

interpretWithReceiver: receiver arg: a1

    ^self interpretWithReceiver: receiver arguments: { a1 }

    "Created: / 06-12-2011 / 21:21:46 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

interpretWithReceiver: receiver arg: a1 arg: a2

    ^self interpretWithReceiver: receiver arguments: { a1 . a2 }

    "Created: / 06-12-2011 / 21:21:54 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

interpretWithReceiver: receiver arg: a1 arg: a2 arg: a3

    ^self interpretWithReceiver: receiver arguments: { a1 . a2 . a3 }

    "Created: / 06-12-2011 / 21:22:05 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

interpretWithReceiver: receiver arguments: arguments

    ^guard evaluateWithReceiver: receiver arguments: arguments

    "Created: / 06-12-2011 / 21:23:23 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!GuardedMethod methodsFor:'building'!

addGuard: aGuard

    guard isNil ifTrue:[
        self assert: aGuard fallback notNil description: 'Attempt set guard without fallback'.
    ] ifFalse:[
        self assert: aGuard fallback isNil description: 'Attempt add guard with fallback'.  
        aGuard fallback: guard.        
    ].
    guard := aGuard.
    self recompile.

    "Created: / 06-12-2011 / 21:37:56 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!GuardedMethod methodsFor:'utilities'!

recompile

    "Nothing to do now, will change later"

    "Created: / 06-12-2011 / 21:38:12 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!GuardedMethod class methodsFor:'documentation'!

version_SVN
    ^ '$Id$'
! !

GuardedMethod initialize!
