"
 Copyright (c) 2010-2011 Jan Vrany, Jan Kurs & Marcel Hlopko,
                         SWING Research Group, Czech Technical University 
                         in Prague

 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the 'Software'), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.
"
"{ Package: 'stx:libjava/experiments' }"

Object subclass:#JavaTypeBox
	instanceVariableNames:''
	classVariableNames:'SmalltalkTypeToBoxDictionary JavaTypeToBoxDictionary'
	poolDictionaries:''
	category:'Languages-Java-Experiments-Types'
!

!JavaTypeBox class methodsFor:'documentation'!

copyright
"
 Copyright (c) 2010-2011 Jan Vrany, Jan Kurs & Marcel Hlopko,
                         SWING Research Group, Czech Technical University 
                         in Prague

 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the 'Software'), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.

"
! !

!JavaTypeBox class methodsFor:'boxing-unboxing'!

initialize
    JavaTypeToBoxDictionary := IdentityDictionary new.
    SmalltalkTypeToBoxDictionary := IdentityDictionary new.

    JavaTypeBox allSubclasses do: [:tb | | inst |
        inst := tb new.        
        JavaTypeToBoxDictionary at: inst javaType put: inst.
        SmalltalkTypeToBoxDictionary at: inst smalltalkType put: inst.
    ].

    "Created: / 31-08-2011 / 22:30:36 / Jan Kurs <kursjan@fit.cvut.cz>"
!

new
    ^ self basicNew initialize

    "Created: / 25-09-2011 / 20:46:23 / Jan Kurs <kursjan@fit.cvut.cz>"
!

typeBoxForJava: javaType
    ^ JavaTypeToBoxDictionary at: javaType asSymbol ifAbsent: [ NoOpTypeBox new. ]

    "Created: / 25-09-2011 / 21:28:27 / Jan Kurs <kursjan@fit.cvut.cz>"
!

typeBoxForSmalltalk: smalltalkType
    ^ SmalltalkTypeToBoxDictionary at: smalltalkType asSymbol ifAbsent: [ NoOpTypeBox new. ]

    "Created: / 25-09-2011 / 21:28:47 / Jan Kurs <kursjan@fit.cvut.cz>"
!

typeBoxForSmalltalkClass: aClass
    | c typeBox |
    c := aClass.

    [c = Object] whileFalse:
    [
        typeBox := SmalltalkTypeToBoxDictionary at: c name ifAbsent: [nil].
        typeBox ifNotNil: [ ^ typeBox ].
        c := c superclass.
    ].
    ^ NoOpTypeBox new.

    "Created: / 25-09-2011 / 21:34:22 / Jan Kurs <kursjan@fit.cvut.cz>"
! !

!JavaTypeBox methodsFor:'boxing-unboxing'!

box: smalltalkObject
    "transform smalltalk object to java object"
    self subclassResponsibility.

    "Created: / 31-08-2011 / 22:43:26 / Jan Kurs <kursjan@fit.cvut.cz>"
!

initialize
    "nothing to do here"

    "Created: / 25-09-2011 / 20:46:34 / Jan Kurs <kursjan@fit.cvut.cz>"
!

javaMessageToSmalltalk: aMessageDescription
    ^ nil

    "Created: / 25-09-2011 / 21:49:42 / Jan Kurs <kursjan@fit.cvut.cz>"
!

javaType
    "return java class I can box to"
    self subclassResponsibility.

    "Created: / 31-08-2011 / 22:39:35 / Jan Kurs <kursjan@fit.cvut.cz>"
!

smalltalkType
    "return smalltalk type, I can unbox to"
    self subclassResponsibility.

    "Created: / 31-08-2011 / 22:39:39 / Jan Kurs <kursjan@fit.cvut.cz>"
!

unbox: javaObject
    "transform java object to smalltalk object"
    self subclassResponsibility.

    "Created: / 31-08-2011 / 22:32:54 / Jan Kurs <kursjan@fit.cvut.cz>"
! !

!JavaTypeBox class methodsFor:'documentation'!

version_SVN
    ^ '$Id$'
! !

JavaTypeBox initialize!
