"
 Copyright (c) 2010-2011 Jan Vrany, Jan Kurs & Marcel Hlopko,
                         SWING Research Group, Czech Technical University 
                         in Prague

 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the 'Software'), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.
"
"{ Package: 'stx:libjava/experiments' }"

Object subclass:#StCounter
	instanceVariableNames:'foo count javaObject'
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Java-Experiments-Tests'
!

!StCounter class methodsFor:'documentation'!

copyright
"
 Copyright (c) 2010-2011 Jan Vrany, Jan Kurs & Marcel Hlopko,
                         SWING Research Group, Czech Technical University 
                         in Prague

 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the 'Software'), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.

"
! !

!StCounter class methodsFor:'instance creation'!

new
    "return an initialized instance"

    ^ self basicNew initialize.
! !

!StCounter class methodsFor:'accessing'!

javaObject
    ^ JavaObjectDictionary new reflectionOf: self name

    "Created: / 09-01-2011 / 21:02:37 / Jan Kurs <kurs.jan@post.cz>"
! !

!StCounter methodsFor:'accessing'!

count
    ^ count
!

inc
    count := count + 2.

    "Created: / 09-01-2011 / 13:51:22 / Jan Kurs <kurs.jan@post.cz>"
!

javaObject
    ^ self class javaObject.
"/    javaObject ifNil: [
"/        javaObject:= Java classForName: 'Counter'.
"/    ].
"/    ^ javaObject.

    "Created: / 09-01-2011 / 13:56:56 / Jan Kurs <kurs.jan@post.cz>"
    "Modified: / 09-01-2011 / 21:02:18 / Jan Kurs <kurs.jan@post.cz>"
! !

!StCounter methodsFor:'error handling'!

doesNotUnderstand:aMessage 
    | method |
    aMessage selector = #'getCount()I' ifTrue:[ ^ self getCount.].
    aMessage selector = #'incCount()V' ifTrue:[ ^ self incCount.].
    method := JavaClass 
                lookupMethod:aMessage selector
                numArgs:aMessage arguments size
                in:self javaObject
                static:false.
    ^ method 
        ifNil:[  super doesNotUnderstand:aMessage.]
        ifNotNil:[ method valueWithReceiver:self arguments:aMessage arguments.]

    "Created: / 09-01-2011 / 13:42:08 / Jan Kurs <kurs.jan@post.cz>"
    "Modified: / 09-01-2011 / 15:54:04 / Jan Kurs <kurs.jan@post.cz>"
! !

!StCounter methodsFor:'initialization'!

initialize
    "Invoked when a new instance is created."
    foo := 123.
    count := 0.

    "/ super initialize.   -- commented since inherited method does nothing

    "Modified: / 09-01-2011 / 15:59:47 / Jan Kurs <kurs.jan@post.cz>"
! !

!StCounter methodsFor:'java protocol'!

getCount
    Transcript showCR: 'aaa'.
    ^ count

    "Created: / 09-01-2011 / 12:59:04 / Jan Kurs <kurs.jan@post.cz>"
    "Modified: / 09-01-2011 / 15:52:19 / Jan Kurs <kurs.jan@post.cz>"
!

incCount
    count := count + 2.

    "Created: / 09-01-2011 / 13:03:29 / Jan Kurs <kurs.jan@post.cz>"
! !

!StCounter methodsFor:'testing'!

isKindOf: aClass
    "This override is neccessary for ST <-> Java Object conversions"
    (self javaObject includesBehavior: aClass) ifTrue:
    [
        ^ true.
    ].
    ^ super isKindOf: aClass.

    "Created: / 09-01-2011 / 13:28:10 / Jan Kurs <kurs.jan@post.cz>"
    "Modified: / 09-01-2011 / 21:22:41 / Jan Kurs <kurs.jan@post.cz>"
! !

!StCounter class methodsFor:'documentation'!

version_SVN
    ^ '$Id$'
! !
