"
 Copyright (c) 2010-2011 Jan Vrany, Jan Kurs & Marcel Hlopko,
                         SWING Research Group, Czech Technical University 
                         in Prague

 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the 'Software'), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.
"
"{ Package: 'stx:libjava/experiments' }"

Object variableByteSubclass:#StHashSet
	instanceVariableNames:'map'
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Java-Experiments-Tests'
!

!StHashSet class methodsFor:'documentation'!

copyright
"
 Copyright (c) 2010-2011 Jan Vrany, Jan Kurs & Marcel Hlopko,
                         SWING Research Group, Czech Technical University 
                         in Prague

 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the 'Software'), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.

"
! !

!StHashSet class methodsFor:'accessing'!

javaObject
    ^ JavaObjectDictionary new reflectionOf: self name

    "Created: / 09-01-2011 / 21:02:37 / Jan Kurs <kurs.jan@post.cz>"
! !

!StHashSet methodsFor:'accessing'!

javaObject
    ^ self class javaObject.
"/    javaObject ifNil: [
"/        javaObject:= Java classForName: 'Counter'.
"/    ].
"/    ^ javaObject.

    "Created: / 09-01-2011 / 13:56:56 / Jan Kurs <kurs.jan@post.cz>"
    "Modified: / 09-01-2011 / 21:02:18 / Jan Kurs <kurs.jan@post.cz>"
! !

!StHashSet methodsFor:'error handling'!

doesNotUnderstand:aMessage 
    | method |
    aMessage selector = #'__map()Ljava/util/HashMap;' ifTrue:[ ^ self getMap].
    aMessage selector = #'__map(Ljava/util/HashMap;)V' ifTrue:[ ^ self setMap: aMessage arguments first.].

    method := JavaClass 
                lookupMethod:aMessage selector
                numArgs:aMessage arguments size
                in:self javaObject
                static:false.

    ^ method 
        ifNil:[ super doesNotUnderstand:aMessage.]
        ifNotNil:[ method valueWithReceiver:self arguments:aMessage arguments.]

    "Created: / 09-01-2011 / 13:42:08 / Jan Kurs <kurs.jan@post.cz>"
    "Modified: / 09-01-2011 / 15:54:04 / Jan Kurs <kurs.jan@post.cz>"
    "Modified: / 24-01-2011 / 16:20:15 / kursjan <kursjan@fit.cvut.cz>"
! !

!StHashSet methodsFor:'java protocol'!

getMap
    map isNil ifTrue: [
        map := (Java classForName:'java.util.HashMap') new.
    ].

    ^ map.

    "Created: / 24-01-2011 / 16:21:45 / kursjan <kursjan@fit.cvut.cz>"
!

setMap: aMap
    map := aMap.

    "Created: / 24-01-2011 / 16:22:34 / kursjan <kursjan@fit.cvut.cz>"
! !

!StHashSet methodsFor:'testing'!

isKindOf: aClass
    "This override is neccessary for ST <-> Java Object conversions"
    (self javaObject includesBehavior: aClass) ifTrue:
    [
        ^ true.
    ].
    ^ super isKindOf: aClass.

    "Created: / 09-01-2011 / 13:28:10 / Jan Kurs <kurs.jan@post.cz>"
    "Modified: / 09-01-2011 / 21:22:41 / Jan Kurs <kurs.jan@post.cz>"
! !

!StHashSet class methodsFor:'documentation'!

version_SVN
    ^ '$Id$'
! !
