package stx.libjava.tools;

import org.eclipse.jdt.core.dom.AST;
import org.eclipse.jdt.core.dom.ASTNode;
import org.eclipse.jdt.core.dom.ASTParser;
import org.eclipse.jdt.core.dom.ASTVisitor;
import org.eclipse.jdt.core.dom.StringLiteral;

public class SyntaxHighlighter extends ASTVisitor {
	protected SyntaxHighlighterHandler handler;

	public SyntaxHighlighter(SyntaxHighlighterHandler handler) {
		this.handler = handler;
	}
	
	public boolean visit(StringLiteral node) {
		handler.markString(node.getStartPosition(), node.getLength());		
		return false;
	}

	public void parseExpression(String source) {
		parseExpression(source.toCharArray());		
	}

	public void parseExpression(char[] source) {
		parse(source, ASTParser.K_EXPRESSION);
	}
	
	protected void parse(char[] source, int kind) {
		ASTParser parser = ASTParser.newParser(AST.JLS3);
		parser.setSource(source);
		parser.setKind(kind);
		parser.createAST(null).accept(this);
	}
	
	

}
